#ifndef TSTORE_RDQL_H
#define TSTORE_RDQL_H

#include <glib.h>

#include "rdql_datatypes.h"
#include "rdfsql_datatypes.h"

rs_rdql_result *rs_rdql_query(RDFSQL *this, const char *query_str,
		int max_comp);
rs_rdql_column *rs_rdql_next_row(rs_rdql_result *res);
void rs_rdql_free_result(rs_rdql_result *res);

pattern_t *new_pattern(part_t *s, part_t *p, part_t *o, part_t *m);
void expand_pattern(pattern_t *p, GSList *prefs);
void print_pattern(pattern_t *p);

part_t *new_part(int type, const char *value);
void expand_part(part_t *p, GSList *prefs);
void print_part(part_t *p);

prefix_t *new_prefix(const char *prefix, const char *uri);

constraint_t *new_constraint(part_t *lval, unsigned int op, part_t *r_val);
void print_constraint(constraint_t *c);

rs_rdql_result *rdql_error(const char *fmt, ...);
void yyerror (char *msg);

#endif
